"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to get private field on non-instance"); } if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to set private field on non-instance"); } if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } return value; }

var appEvent = require('../event');

var _router = new WeakMap();

var ServerApi = /*#__PURE__*/function () {
  function ServerApi(router) {
    _classCallCheck(this, ServerApi);

    _router.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _router, router);
  }

  _createClass(ServerApi, [{
    key: "registerRouter",
    value: function registerRouter(_ref) {
      var _this = this;

      var routes = _ref.routes,
          routePath = _ref.routePath,
          routeId = _ref.routeId;

      if (Array.isArray(routes)) {
        routes.forEach(function (_ref2) {
          var method = _ref2.method,
              path = _ref2.path,
              callback = _ref2.callback;

          _classPrivateFieldGet(_this, _router)[method](path, callback);
        });
      } else {
        _classPrivateFieldGet(this, _router)[routes.method](routes.path, routes.callback);
      }

      appEvent.emit('routerRefresh', {
        routes: _classPrivateFieldGet(this, _router),
        routePath: routePath,
        routeId: routeId
      });
    }
  }]);

  return ServerApi;
}();

module.exports = ServerApi;