"use strict";

var _require = require('./handler'),
    getAllPlugins = _require.getAllPlugins,
    getBundleJson = _require.getBundleJson,
    getTextFile = _require.getTextFile,
    watchTaskLog = _require.watchTaskLog,
    watchTasksStatus = _require.watchTasksStatus;

var getApi = {
  '/api/bundle/json': getBundleJson,
  '/api/bundle/file': getTextFile,
  '/api/plugin': getAllPlugins
};
var postApi = {
  '/api/tasks/logs/watch': watchTaskLog,
  '/api/tasks/status/watch': watchTasksStatus
};
module.exports = {
  getApi: getApi,
  postApi: postApi
};