"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var express = require('express');

var _require = require('../utils/utils'),
    getGlobalItem = _require.getGlobalItem;

var router = express.Router();
var HPM_API = getGlobalItem('api');
router.get('/bundle', /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
    var _req$query, searchKey, curPage, pageSize, publishAs, version, result, _yield$HPM_API$search, data;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _req$query = req.query, searchKey = _req$query.searchKey, curPage = _req$query.curPage, pageSize = _req$query.pageSize, publishAs = _req$query.publishAs, version = _req$query.version;
            result = {
              code: 200,
              message: 'success'
            };
            _context.next = 5;
            return HPM_API.search({
              searchKey: searchKey,
              curPage: curPage,
              publishAs: publishAs,
              pageSize: pageSize,
              ver: version
            });

          case 5:
            _yield$HPM_API$search = _context.sent;
            data = _yield$HPM_API$search.data.data;
            result.data = data;
            res.send(result);
            _context.next = 14;
            break;

          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](0);
            next(_context.t0);

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 11]]);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}());
module.exports = router;