"use strict";

var SocketType = {
  CONNECTED: 'CONNECTED',
  START: 'START',
  DATA: 'DATA',
  DONE: 'DONE',
  STOP: 'STOP'
};
var TaskType = {
  cmd: 'cmd',
  hook: 'hook',
  script: 'script',
  plugin: 'plugin'
};
var fileMap = new Map([['dataUrl', 'subsystem.json'], ['manifestUrl', 'manifest.json'], ['logicUrl', 'logic.js'], ['templateUrl', 'template.zip']]);
module.exports = {
  SocketType: SocketType,
  TaskType: TaskType,
  fileMap: fileMap
};